ideal
THANKS=1
VER	equ	'4.20.000'
model	tiny
jumps
p186
include	"tinylib.asi"
codeseg
startupcode
	pop	ax
	mov	sp,offset eopr
	push	ax
	string	<'Extended Sound Player V ',VER,'  Copyright (c) Programmist X',13,10,13,10>
	mov	bx,cs
	mov	ax,offset eopr+15
	shr	ax,4
	add	ax,bx
	and	ax,0F000h
	add	ax,1000h
	mov	[dmaseg],ax
	add	ax,1000h
	mov	[extseg],ax
	add	ax,1000h
	cmp	ax,[2]
	jbe	@@pp
	string	<'Not enough memory',13,10>
	ret
;	
@@pp:	cmdline
	 cmdarg	@srb,"/SB"
	 cmdarg	@sr2,"/SR2"
	 cmdarg	@sr3,"/SR3"
	 cmdarg	@sr4,"/SR4"
	 cmdarg	@sr8,"/SR8"
	 cmdarg	@sr16,"/SR16"
	 cmdarg	@ds2,"/DS2"
	 cmdarg	@ds3,"/DS3"
	 cmdarg	@ds4,"/DS4"
	 cmdarg	@ds8,"/DS8"
	 cmdarg	@cv1,"/C1"
	 cmdarg	@cv2,"/C2"
	 cmdarg	@cv1,"/C"
	 cmdarg	@spk,"/S"
	 cmdarg	@sbl,"/B"
	 cmdarg	@lck,"/L"
	 cmdarg	@frq,"/U:"
	 cmdarg	@dfr,"/F:"
	 cmdarg	@vol,"/V:"
	 cmdarg	@cou,"/N:"
	 cmdarg	@ehlp,"/??"
	 cmdarg	@hlp,"/?"
	 cmdarg	@fn,""
	cmdarg
	test	[mode],80h
	jnz	@@x1
	string	<'Type /? for help',13,10>
@@x1:	ret
;	
@srb:	mov	[srcmp],6
	mov	[dscm],1
	mov	[cmpd],0
	or	[mode],5h
	ret
;	
@sr2:	mov	[srcmp],3
	or	[mode],10h
	ret
;	
@sr3:	mov	[srcmp],2
	or	[mode],10h
	ret
;	
@sr4:	mov	[srcmp],1
	or	[mode],10h
	ret
;	
@sr8:	mov	[srcmp],0
	or	[mode],10h
	ret
;	
@sr16:	mov	[srcmp],4
	or	[mode],10h
	ret
;	
@ds8:	mov	[dscm],1
	mov	[cmpd],0
	or	[mode],1
	ret
;	
@ds4:	mov	[dscm],2
	mov	[cmpd],1
	or	[mode],1
	ret
;	
@ds3:	mov	[dscm],3
	mov	[cmpd],2
	or	[mode],1
	ret
;	
@ds2:	mov	[dscm],4
	mov	[cmpd],3
	or	[mode],1
	ret
;	
@spk:	mov	[dev],0
	or	[mode],40h
	ret
;	
@cv1:	mov	[dev],1
	or	[mode],40h
	ret
;	
@cv2:	mov	[dev],2
	or	[mode],40h
	ret
;	
@sbl:	mov	[dev],3
	or	[mode],40h
	ret
;	
@lck:	or	[mode],2
	ret
;	
@fn:	or	[mode],80h
;	int	3
	getarg	dx
	test	[eop],40h
	jnz	@@ee
	test	[mode],1
	jnz	@@e1
	mov	[fn1],dx
@@re:	push	ds
;	int	3
	call	splay
	pop	ds
	mov	ax,[cs:count]
	dec	ax
	jz	@@ee
	test	[eop],20h
	jnz	@@ee
	mov	[cs:count],ax
	jmp	@@re
;	
@@ee:	and	[mode],0EFh
	mov	[fn1],0
	ret
;	
@@e1:	test	[mode],4
	jnz	@@e2
	cmp	[fn1],0
	jnz	@@e2
	mov	[fn1],dx
	ret
;	
@@e2:	mov	[fn2],dx
	;int	3
	call	sconv
	mov	[fn1],0
	and	[mode],0FAh
	ret
;	
@frq:	getint	ax
	cmp	ax,32768
	jz	@@e1
	cmp	ax,80
	ja	@@e2
	mov	dx,501;1000
	mul	dx
	jmp	@@e3
;		
@@e2:	cmp	ax,4000
	jb	@@e1
	shr	ax,1
@@e3:	;and	[mode],0DFh
	mov	[freq],ax
;	call	@setfrq
	or	[mode],20h
@@e1:	ret
;	
@dfr:	and	[mode2],0FEh
	getint	ax
	cmp	ax,32768
	jz	@@e1
	cmp	ax,80
	ja	@@e2
	mov	dx,501
	mul	dx
	jmp	@@e3
;	
@@e2:	cmp	ax,4000
	jb	@@e1
	shr	ax,1
@@e3:	mov	[dfrq],ax
	or	[mode2],1
@@e1:	ret
;	
@vol:	getint	ax
	cmp	ax,32768
	jz	@@d1
@@d2:	cmp	ax,160
	jbe	@@d3
	mov	al,160
@@d3:	mov	[svol],al
@@d1:	ret
;	
@cou:	getint	ax
	test	ax,7FFFh
	jnz	@@c1
	mov	ax,1
@@c1:	mov	[count],ax
	ret
;	
@hlp:	or	[mode],80h
	string
	db	'USAGE:  XPLAY [options] <file1> [[options] file2 [...]]',13,10
	db	13,10
	db	' Valid options:',13,10
	db	'   /SR# - set number of bits per sample for source file (2,3,4,8 or 16)',13,10
	db	'   /DS# - set number of bits per sample for destination file (2,3,4 or 8)',13,10
	db	'          (This option is also switch to convert mode)',13,10
	db	'   /SB  - source-SB (record mode)',13,10
	db	13,10
	db	'   /S   - play on PC Speaker (default)',13,10
	db	'   /C   - play on Covox',13,10
	db	'   /C2  - play on Covox 2',13,10
	db	'   /B   - play on Sound Blaster',13,10
	db	'   /?   - show this help (/?? for more help)',13,10
	db	13,10
	db	'   /U:N - set sample rate of SOURCE to N Hz',13,10
	db	'   /F:N - set sample rate of TARGET to N Hz',13,10
	db	'   /V:N - set volume [0..160], default 32',13,10
	db	'   /N:N - repeat count',13,10
	db	'   /L   - disable sound while DOS active',13,10
	db	0
	getkey
	string
	db	13,10
	db	'EXAMPLES:',13,10
	db	' XPLAY /S /V:90 TEST.WAV              - play TEST.WAV on PC Speaker',13,10
	db	' XPLAY /SR4 /C ALARM.VOC              - play ALARM.VOC on Covox as 4-bit ADPCM',13,10
	db	' XPLAY /DS3 INFILE.WAV OUTFILE.VOC    - compress INFILE.WAV to OUTFILE.VOC',13,10
	db	' XPLAY /SB /F:11025 /V:90 /DS4 11.VOC - record 11.VOC as 11025 Hz, 4-bit ADPCM',13,10
	db	13,10
	db	' Use SET TMP=DRIVE:\DIRECTORY to define directory for temporary files',13,10
	db	' Use SET BLASTER=A<port> I<irq> D<dma> to define Sound Blaster parameters',13,10
	db	0
	ret
; 
proc	splay
	enter	0,3
	call	setbl	
	test	[mode],40h
	jnz	@@pe
	call	dspres
	jc	@@pe
	mov	[dev],3
	jmp	@@pe1
;	
@@pe:	cmp	[dev],0
	jnz	@@pe1
	test	[mode2],1
	jnz	@@pe1
	or	[mode2],1
	mov	[dfrq],22050
@@pe1:	call	splpt
	mov	dx,[fn1]
	mov	ax,3D00h
	int	21h
	jnc	@@o1
	call	@open
	jmp	@@oo
;	
@@o1:	mov	[inf],ax
	mov	bx,ax
	call	tstfrm
	jnc	@@o2
	call	@form
	jmp	@@oo
;	
@@o2:	string	'Playing '
	mov	bl,[cs:dev]
	mov	bh,0
	shl	bx,1
	push	bx
	call	[cs:initdev+bx]
	jnc	@@m1
	call	@devc
	pop	bx
	jmp	@@oo
;	
@@m1:	;int	3
	mov	[cs:sh16],8
	mov	bl,0
	cmp	[cs:dev],0
	jnz	@@m1c
	mov	bl,[cs:tim]
@@m1c:	mov	bh,[cs:svol]
;	cmp	[cs:srcmp],4
;	jnz	@@m1a
;@@m1b:	cmp	bh,64
;	jb	@@m1a
;	shr	bh,1
;	dec	[cs:sh16]
;	jmp	@@m1b
;	
@@m1a:	call	calcc
	;int	3
	mov	[cs:playcnt],0
	mov	[cs:eop],0
	mov	[cs:cbyte],80h
	mov	[cs:cstat],0
	mov	[cs:_oldbp],-1
	mov	[cs:_oldsi],offset prebuf+32760
	
	call	hook1
	
	mov	ds,[cs:dmaseg]
	mov	dx,0
	mov	cx,32760
	call	fread
	mov	[cs:bufo],cx
;	mov	dx,32760
;	mov	cx,32760
;	call	fread
	
	pop	bx
	push	bx
	
	call	[cs:playdev+bx]
	;int	3
@@m2:	test	[cs:eop],80h
	jnz	@@m3
	inkey
	jz	@@m2
	getkey
	or	[cs:eop],20h
	cmp	ah,1
	jnz	@@m3
	or	[cs:eop],40h
@@m3:
	string	<' done',13,10>
	
	call	leav1
	
	pop	bx
;	push	bx
	call	[cs:closdev+bx]
;	pop	bx
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	mov	bx,[inf]
	mov	ah,3Eh
	int	21h
@@oo:	
	leave
	ret
endp
; 
proc	hook1
	mov	ax,351Bh
	int	21h
	mov	[oi1b],bx
	mov	[oi1b+2],es
	mov	ax,251Bh
	mov	dx,offset int1b
	int	21h
	ret
endp
;	
proc	leav1
	lds	dx,[dword cs:oi1b]
	mov	ax,251Bh
	int	21h
	push	cs
	pop	ds
	ret
endp
; 
proc	sconv
	mov	[cs:playptr],0
	call	splpt
	call	gettmp
	test	[mode],4
	jz	@@x1a
	call	inisbr
	jc	@nosb
	
@@pe:	jmp	@@x2
;	
@@x1a:	mov	dx,[fn1]
	mov	ax,3D00h
	int	21h
	jnc	@@x1
	call	@open
	ret
;	
@@x1:	mov	[inf],ax
	mov	bx,ax
	call	tstfrm
	jnc	@@x2
	call	@form
	jmp	@@x0
;	
@@x2:	mov	dx,offset unifn
	xor	cx,cx
	mov	ah,5Ah
	int	21h
	jnc	@@x4
	call	@crtm
	jmp	@@x0	
;	
@@x4:	mov	[outf],ax
	mov	bh,[cs:svol]
	call	calcc
	call	puthdr
	
	call	hook1
	call	encode
	
	
	call	endhdr
	jmp	@@x9
;	
@@x0:	mov	bx,[inf]
	mov	ah,3Eh
	int	21h
	ret
;	
@@x9:	call	@@x0
	call	leav1
	test	[mode],4
	jz	@@x10
	;int	3
	enter	0,3
	call	clssb
	leave
@@x10:	mov	bx,[outf]
	mov	ah,3Eh
	int	21h
	push	cs
	pop	es

	mov	dx,[fn2]
	mov	ah,41h
	int	21h
	mov	dx,offset unifn
	mov	di,[fn2]
	mov	ah,56h
	int	21h
	jnc	@@x7
	mov	dx,offset unifn
	mov	ax,3D00h
	int	21h
	jc	@@x7
	mov	[inf],ax
	mov	bx,ax
	mov	dx,[fn2]
	xor	cx,cx
	mov	ah,3Ch
	int	21h
	jnc	@@x6
@@x5:	call	@crea
	jmp	@@x7
;	
@@x6:	mov	si,ax
	mov	bx,[inf]
	xor	cx,cx
	xor	dx,dx
	mov	ax,4200h
	int	21h
	mov	dx,offset prebuf
@@x8:	mov	cx,32768
	mov	ah,3fh
	int	21h
	mov	cx,ax
	xchg	bx,si
	mov	ah,40h
	int	21h
	xchg	bx,si
	cmp	ax,32768
	jz	@@x8
	mov	ah,3Eh
	int	21h
	xchg	bx,si
	mov	ah,3Eh
	int	21h
	mov	dx,offset unifn
	mov	ah,41h
	int	21h
@@x7:	ret
endp
; 
proc	splpt
;	int	3
	mov	[plpt],100h
	test	[mode2],1
	jz	@@s1
@@s4:	mov	ax,[freq]
	mov	dx,128
	mov	cx,[dfrq]
	mul	dx
	div	cx
	mov	[plpt],ax
	jmp	@@s2
;	
@@s3:	mov	[dfrq],22050
	jmp	@@s4
;	
@@s1:	mov	cx,[freq]
	mov	[dfrq],cx
@@s2:	mov	dx,07h
	mov	ax,0A120h
	cmp	cx,dx
	jbe	@@s3
	div	cx
	neg	al
	mov	[sbtc],al

	ret
endp
; 
proc	setbl
	;int	3
	mov	es,[2Ch]
	xor	di,di
@@m0:	mov	cx,8
	mov	si,offset blast
	repz	cmpsb
	jz	@@s1
	xor	al,al
	mov	cx,32768
	repnz	scasb
	cmp	[es:di],al
	jnz	@@m0
@@s0:	push	cs
	pop	es
	ret
;	
@@s1:	mov	si,di
@@sy:	seges
	lodsb
@@sx:	cmp	al,'a'
	jb	@@s2
	cmp	al,'z'
	ja	@@s2
	sub	al,20h
@@s2:	cmp	al,'A'
	jnz	@@s3
	call	getbcd
	cmp	bh,2
	jnz	@@sx
	test	bl,0Fh
	jnz	@@sx
	mov	[sbport],bx
	jmp	@@sx
;	
@@s3:	cmp	al,'I'
	jnz	@@s4
;	int	3
	call	getbcd
	mov	ah,bl
	and	bl,0F0h
	shr	bl,1
	mov	bh,bl
	shr	bl,2
	add	bl,bh
	and	ah,0Fh
	add	bl,ah
	cmp	bl,16
	jae	@@sx
	mov	[sbirq],bl
	cmp	bl,7
	ja	@@s3a
	mov	[word @enop],9090h
	mov	[word @enop2],9090h
@@s3a:	jmp	@@sx
;	
@@s4:	cmp	al,'D'
	jnz	@@s5
	call	getbcd
	cmp	bx,3
	ja	@@sx
	mov	[sbdma],bl
	jmp	@@sx
;	
@@s5:	and	al,al
	jz	@@s6
	jmp	@@sy
;	
@@s6:	ret
;	
getbcd:	xor	bx,bx
@@g2:	seges
	lodsb
	cmp	al,'0'
	jb	@@g1
	cmp	al,'9'
	ja	@@g1
	and	al,0Fh
	shl	bx,4
	or	bl,al
	jmp	@@g2
@@g1:	ret
endp
; 
proc	gettmp
	mov	es,[2Ch]
	xor	di,di
@@m0:	mov	cx,4
	mov	si,offset tmpvar
	repz	cmpsb
	jz	@@m1
	xor	al,al
	mov	cx,32768
	repnz	scasb
	cmp	[es:di],al
	jnz	@@m0
	push	cs
	pop	es
	mov	di,offset unifn
	xor	al,al
	stosb
	ret
;	
@@m1:	push	ds es di
	pop	si ds es
	xor	al,al
	mov	di,offset unifn
@@m3:	movsb
	dec	di
	scasb
	jnz	@@m3
	push	cs
	pop	ds
	ret
endp
; 
proc	errors
@form:	string	<'Input file format not supported',13,10>
	ret
@open:	string	<'Cannot open input file',13,10>
	ret
@crea:	string	<'Cannot create output file',13,10>
	ret
@crtm:	string	<'Cannot create temporary file',13,10>
	ret
@devc:	string	<13,10,'Selected device not found',13,10>
	ret
@nosb:	string	<13,10,'Sound Blaster not found!!!',13,10>
	ret
endp
; 
proc	encode
	test	[mode],4
	jnz	@@e1
	string	'Converting '
	jmp	@@e2
;	
@@e1:	string	'Recording '
	mov	[cs:reccnt],0
	;int	3
@@e2:	mov	[cs:cbyte],80h
	mov	[cs:cstat],0
	mov	[cs:cbt1],80h
	mov	[cs:cst1],0
	mov	[cs:eop],0
	mov	[cs:_oldbp],-1
	mov	[cs:_oldsi],offset prebuf+32760

	mov	ds,[cs:dmaseg]
	mov	ax,32760
	cwd
	mov	cl,[cs:dscm]
	mov	ch,0
	div	cx
	mov	[cs:outln],ax
;	mov	bx,cx
;	shl	bx,1
;	mov	ax,[cs:compp+bx-2]
;	mov	[cs:coder],ax
	
	mov	ax,[cs:extseg]
	mov	ds,ax
	mov	es,ax
;	int	3
@@m1:	xor	dx,dx
	mov	cx,32760
	call	fread
	mov	cx,ax
	jcxz	@@m1a
	xor	si,si
	mov	di,32768
	mov	bl,[cs:cmpd]
	mov	bh,0
	shl	bx,1
	call	[cs:compp+bx]
;	mov	cx,ax
	mov	dx,32768
	mov	bx,[cs:outf]
	mov	ah,40h
	int	21h
	cmp	cx,[cs:outln]
	jz	@@m1
	
@@m1a:	string	<' done',13,10>
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	ret
endp
; 
proc	puthdr
	mov	bx,[outf]
	mov	dx,offset exa4
	mov	cx,32
	mov	ah,40h
	int	21h
	
	ret
endp
; 
proc	endhdr
	;int	3
	
	xor	cx,cx
	xor	dx,dx
	mov	bx,[outf]
	mov	ax,4201h
	int	21h
	push	ax dx
	mov	dx,offset exa4+21
	mov	cx,1
	mov	ah,40h
	int	21h
	pop	dx ax
	sub	ax,30
	sbb	dx,0
	mov	[word exa4+27],ax
	mov	[byte exa4+29],dl
	mov	dx,27
	xor	cx,cx
	mov	ax,4200h
	int	21h
	mov	dx,offset exa4+27
	mov	cx,3
	mov	ah,40h
	int	21h
	ret
endp
; 
proc	inispk
	;int	3
	push	es cs
	pop	es
	mov	di,offset spkxlt
	mov	bl,[cs:sptim]
	xor	bh,bh
@@e1:	mov	al,bh
	mul	bl
	mov	al,ah
	stosb
	inc	bh
	jnz	@@e1
	
	mov	bl,[cs:sbtc]
	neg	bl
	mov	bh,0
	mov	ax,215
	mov	dl,[cs:sptim]
	xor	dh,dh
	mul	dx
	div	bx
	mov	[cs:plpt],ax
	
	call	@ini0
	mov	[cs:oport],42h
	mov	al,[cs:sptim]
	out	40h,al
	halt	2
	xor	al,al
	out	40h,al
	mov	al,90h
	out	43h,al
	halt	2
	in	al,61h
	halt	2
	or	al,3
	out	61h,al
	halt	2
	clc
	pop	es
	ret
endp
; 
proc	inicov
	push	es
	
	xor	ax,ax
	mov	es,ax
	mov	bl,[cs:dev]
	xor	bh,bh
	shl	bx,1
	mov	ax,[es:406h+bx]
	and	ax,ax
	jnz	@w1
	pop	es
	stc
	ret
;	
@ini0:	push	es
@w1:	mov	[cs:oport],ax
	mov	ax,cs
	mov	ds,ax
	mov	es,ax

	mov	[cs:playptr],-1
	mov	[cs:playlen],1;65520/DMADIV

	cli
	in	al,21h
	halt	2
	or	al,1
	out	21h,al
	halt	2
	call	seti0
	
	mov	al,[cs:sbtc]
	neg	al
	xor	ah,ah
	mov	dx,39096
	mul	dx
	shl	ax,1
	rcl	dx,1
	mov	[cs:tim],dl
	mov	al,36h
	out	43h,al
	halt	2
	mov	al,dl
	out	40h,al
	halt	2
	mov	al,0
	out	40h,al
	sti
	clc
	pop	es
	ret
endp
; 
proc	inisb
	call	dspres
	jnc	@@e1
	ret
;	
@@e1:	
	push	es
	xor	ax,ax
	mov	es,ax
	cli
	;int	3
	call	_evint
	mov	ax,[es:bx]
	mov	[cs:oi5],ax
	mov	ax,[es:bx+2]
	mov	[cs:oi5+2],ax
	mov	[word es:bx],offset irq5
	mov	[word es:bx+2],cs
	

	in	al,dx
	and	al,ch
	out	dx,al
	sti
	
	mov	dx,[cs:sbport]
	add	dl,4
	mov	al,0Eh
	out	dx,al
	halt	2
	inc	dx
	in	al,dx
	and	al,0FDh
	cmp	[cs:chs],2
	jnz	@@mo
	or	al,2
@@mo:	out	dx,al
	
	mov	al,[cs:sbtc]
	
	mov	[byte bp-3],al
	mov	[word bp-5],4002h
	lea	si,[bp-5]
	call	putdsp
	
	mov	[word bp-4],0D101h
	lea	si,[bp-4]
	call	putdsp
	
	mov	[cs:dmamod],58h
	call	setdma

	clc
	pop	es
	ret
endp
; 
proc	inisbr
	call	dspres
	jnc	@@e1
	ret
;	
@@e1:	
	enter	0,3
	push	es
	xor	ax,ax
	mov	es,ax
	cli
	;int	3
	call	_evint
	mov	ax,[es:bx]
	mov	[cs:oi5],ax
	mov	ax,[es:bx+2]
	mov	[cs:oi5+2],ax
	mov	[word es:bx],offset irq5r
	mov	[word es:bx+2],cs
	

	in	al,dx
	and	al,ch
	out	dx,al
	sti
	
	mov	al,[cs:sbtc]
	
	mov	[byte bp-3],al
	mov	[word bp-5],4002h
	lea	si,[bp-5]
	call	putdsp
	
	mov	[word bp-4],0D101h
	lea	si,[bp-4]
	call	putdsp

	mov	[word bp-4],0A001h
	lea	si,[bp-4]
	call	putdsp
	
	mov	[cs:dmamod],54h
	call	setdma

	mov	[word bp-6],0F201h
	lea	si,[bp-6]
	call	putdsp

	pop	es
	leave
	clc
	ret
endp
; 
proc	seti0
	xor	ax,ax
	mov	es,ax
	mov	ax,[es:08h*4]
	mov	[cs:oi8],ax
	mov	ax,[es:08h*4+2]
	mov	[cs:oi8+2],ax
	cmp	[cs:dev],0
	jnz	@@s2
	mov	ax,offset irqs0
	
	jmp	@@s1
;	
@@s2:	mov	ax,offset irq0
	test	[cs:mode],2
	jz	@@s1
	mov	ax,offset irq0s
@@s1:	mov	[word es:08h*4],ax
	mov	[word es:08h*4+2],cs
	ret
endp
; 
; BH = volume
; BL = upper limit
proc	calcc
	;int	3
	enter	0,4
	cld
	push	es cs
	pop	es
	mov	di,offset xltbl
	cmp	bh,32
	jae	@@c1
	mov	dl,bh
	shl	dl,2
	mov	dh,-128
@@c2:	mov	al,dh
	imul	dl
	shl	ax,1
	mov	al,ah
	add	al,80h
	and	bl,bl
	jz	@@c4
	mul	bl
	mov	al,ah
@@c4:	stosb
	inc	dh
	cmp	dh,-128
	jnz	@@c2
	jmp	@@c3
;	
@@c1:	mov	cl,bh
	xor	ch,ch
	shl	cx,3
	mov	[bp-2],cx		; V
	mov	dx,1
	xor	ax,ax
	div	cx
	add	ax,cx
	sub	ax,512
	mov	cx,ax
	mov	dx,-3
	imul	dx
	mov	[bp-4],ax		; B
	shl	cx,1
	add	cx,[bp-2]
	dec	ch
	mov	[bp-8],cx		; D
	mov	ax,256
	sub	ax,[bp-2]
	sub	ax,[bp-4]
	sub	ax,[bp-8]
	mov	[bp-6],ax		; C
	mov	cx,256
	mov	si,-256
@@e1:	mov	ax,[bp-8]
	and	si,si
	jns	@@e2
	neg	ax
@@e2:	imul	si
	mov	al,ah
	mov	ah,dl
	add	ax,[bp-6]
	imul	si
	mov	al,ah
	mov	ah,dl
	and	si,si
	jns	@@e3
	sub	ax,[bp-4]
	jmp	@@e4
;	
@@e3:	add	ax,[bp-4]
@@e4:	imul	si
	mov	al,ah
	mov	ah,dl
	add	ax,[bp-2]
	imul	si
	shr	dl,1
	rcr	ah,1
	mov	al,ah
	add	al,80h
	stosb
	inc	si
	inc	si
	loop	@@e1
@@c3:	pop	es
	leave
	ret
endp

; 
proc	plaspk
;	mov	bl,[cs:tim]
;	mov	bh,[cs:svol]
;	call	calcc
;	mov	ax,[cs:playcnt]
;	mov	[cs:playlen],ax
	int	8

	in	al,21h
	halt	2
	and	al,0FEh
	out	21h,al
	halt	2
	sti
	ret
endp
; 
proc	placov
;	mov	bl,0
;	mov	bh,[cs:svol]
;	call	calcc

	in	al,21h
	halt	2
	and	al,0FEh
	out	21h,al
	halt	2
	sti
	ret
endp
; 
proc	plasb

	mov	[word bp-6],0F201h
	lea	si,[bp-6]
	call	putdsp
	ret
endp
; 
proc	clsspk
	call	clscov
	in	al,61h
	halt	2
	and	al,0FCh
	out	61h,al
	halt	2
	mov	al,0B6h
	out	43h,al
	halt	2
	mov	ax,1491
	out	42h,al
	halt	2
	mov	al,ah
	out	42h,al
	halt	2
	sti
	ret
endp
; 
proc	clscov
	cli
	push	es
	xor	ax,ax
	mov	es,ax
	mov	ax,[cs:oi8]
	mov	[es:08h*4],ax
	mov	ax,[cs:oi8+2]
	mov	[es:08h*4+2],ax
	
	in	al,21h
	halt	2
	and	al,0FEh
	out	21h,al
	halt	2
	xor	ax,ax
	out	40h,al
	halt	2
	mov	al,ah
	out	40h,al
	halt	2
	pop	es
	sti
	ret
endp
; 
proc	clssb

;	mov	[word bp-4],0D001h
;	lea	si,[bp-4]
;	call	putdsp
	
	call	dspres
	mov	[word bp-4],0D301h
	lea	si,[bp-4]
	call	putdsp

;	call	dspres
	
	cli
	push	es
	xor	ax,ax
	mov	es,ax
	
	call	_evint
	mov	ax,[cs:oi5]
	mov	[es:bx],ax
	mov	ax,[cs:oi5+2]
	mov	[es:bx+2],ax
	sti
	pop	es
	ret
endp
; 
proc	_evint
	xor	bh,bh
	mov	cl,[cs:sbirq]
	mov	bl,cl
	add	bl,8
	cmp	bl,10h
	jb	@@e1a
	add	bl,60h
@@e1a:	shl	bx,2
	mov	dx,21h
	test	cl,8
	jz	@@e1b
	mov	dx,0A1h
@@e1b:	and	cl,7
	mov	ch,0FEh
	rol	ch,cl
	ret
endp
; 
proc	putdsp
	push	ax cx dx
	segss
	lodsb
	mov	ah,al
	mov	dx,[cs:sbport]
	add	dl,0Ch
@@m0:	xor	cx,cx
@@m1:	in	al,dx
	test	al,80h
	loopnz	@@m1
	jcxz	@@m2
	segss
	lodsb
	out	dx,al
	dec	ah
	jnz	@@m0
	clc
@@m3:	pop	dx cx ax
	ret
@@m2:	stc
	jmp	@@m3
endp
; 
proc	setdma
	;int	3
	mov	dl,[cs:sbdma]
	mov	al,dl
	or	al,4
	out	0Ah,al
	and	al,3
	or	al,[cs:dmamod]
	out	0Bh,al
	and	dx,3
	shl	dx,1
	mov	ax,[cs:dmaseg]
	rol	ax,4
	mov	bx,ax
	and	ax,0FFF0h
	out	0Ch,al
	halt	2
	out	dx,al
	halt	2
	mov	al,ah
	out	dx,al
	halt	2
	out	0Ch,al
	mov	ax,65519;DMABUF-1
	inc	dx
	out	dx,al
	halt	2
	mov	al,ah
	out	dx,al
	mov	al,bl
	and	al,0Fh
	mov	bl,[cs:sbdma]
	xor	bh,bh
	mov	dl,[cs:dmapg+bx]
	out	dx,al
	halt
	mov	al,bl
	out	0Ah,al
	
	ret
endp
; 
proc	int1b
	push	ds 0
	pop	ds
	and	[byte 471h],7Fh
	or	[cs:eop],41h
	pop	ds
	iret
endp
; 
proc	irqs0
	push	ax bx si dx
	push	ds
	cld
	mov	al,20h
	out	20h,al
	mov	al,[cs:eop]
	test	al,8
	jnz	@@k1
	shr	al,1
	and	al,[cs:mode]
	test	al,2
	jnz	@@k1
	mov	si,[cs:playptr]
	mov	ds,[cs:dmaseg]
	mov	al,[si]
	mov	bx,offset spkxlt
	segcs
	xlat
	out	42h,al
	xor	ah,ah
	mov	al,[cs:delta]
	add	ax,[cs:plpt]
	mov	[cs:delta],al
	mov	al,ah
	cbw
	add	[cs:playptr],ax
	sub	[cs:playlen],ax
	ja	@@k1
	cmp	si,65520
	jb	@@k3
	mov	[cs:playptr],0
@@k3:	
	test	[cs:eop],2
	jz	@@k5
	or	[cs:eop],8
	jmp	@@k1
;	
@@k5:	and	[cs:eop],0F7h
	or	[cs:eop],2
	sti
	mov	ax,[cs:playcnt]
	and	ax,ax
	jnz	@@k4
	or	[cs:eop],80h
	jmp	@@k1
;	
@@k4:	mov	[cs:playlen],ax
	mov	[cs:playcnt],0
	call	@swap
	and	[cs:eop],0FDh
	test	[cs:eop],8
	jnz	@@k5
@@k1:	pop	ds
	pop	dx si bx ax
	iret
endp
; 
proc	irq0
	push	ax bx si dx
	push	ds
	cld
	mov	al,20h
	out	20h,al
	test	[cs:eop],8
	jnz	@@k1
	mov	dx,[cs:oport]
	mov	si,[cs:playptr]
	mov	ds,[cs:dmaseg]
	lodsb
;	mov	bx,offset xltbl
;	segcs
;	xlat
	out	dx,al
	mov	[cs:playptr],si
	dec	[cs:playlen]
	jnz	@@k1
	cmp	si,65520
	jnz	@@k3
	mov	[cs:playptr],0
@@k3:	test	[cs:eop],2
	jz	@@k5
	or	[cs:eop],8
	jmp	@@k1
;	
@@k5:	and	[cs:eop],0F7h
	mov	ax,[cs:playcnt]
	and	ax,ax
	jnz	@@k6
	or	[cs:eop],80h
	jmp	@@k1
;	
@@k6:	mov	[cs:playlen],ax
	mov	[cs:playcnt],0
	and	[cs:eop],0F7h
	or	[cs:eop],2
	sti
	call	@swap
	and	[cs:eop],0FDh
	test	[cs:eop],8
	jnz	@@k5
	
@@k1:	pop	ds
	pop	dx si bx ax
	iret
endp
; 
proc	irq0s
	push	ax bx si dx
	push	ds
	cld
	mov	al,20h
	out	20h,al
	test	[cs:eop],0Ch
	jnz	@@k1
	mov	dx,[cs:oport]
	mov	si,[cs:playptr]
	mov	ds,[cs:dmaseg]
	lodsb
;	mov	bx,offset xltbl
;	segcs
;	xlat
	out	dx,al
	mov	[cs:playptr],si
	dec	[cs:playlen]
	jnz	@@k1
	cmp	si,65520
	jnz	@@k3
	mov	[cs:playptr],0
@@k3:	test	[cs:eop],2
	jz	@@k5
	or	[cs:eop],8
	jmp	@@k1
;	
@@k5:	and	[cs:eop],0F7h
	mov	ax,[cs:playcnt]
	and	ax,ax
	jnz	@@k6
	or	[cs:eop],80h
	jmp	@@k1
;	
@@k6:	mov	[cs:playlen],ax
	mov	[cs:playcnt],0
	and	[cs:eop],0F7h
	or	[cs:eop],2
	sti
	call	@swap
	and	[cs:eop],0FDh
	test	[cs:eop],8
	jnz	@@k5
	
@@k1:	pop	ds
	pop	dx si bx ax
	iret
endp
; 
proc	irq5
	;int	3
	push	ax dx
	mov	al,20h
@enop:	out	0A0h,al
	out	20h,al
	mov	dx,[cs:sbport]
	add	dl,0Eh
	in	al,dx

;	int	3
	test	[cs:eop],2
	jz	@@m1
;	int	3
	or	[cs:eop],8
	jmp	@@m0
;	
@@m1:	and	[cs:eop],0F7h
	mov	ax,[cs:playcnt]
	dec	ax
	jns	@@m2
	or	[cs:eop],80h
	jmp	@@m0
;	
@@m2:	push	si ax 1403h
	mov	si,sp
	call	putdsp
	pop	si si si
	sti
	mov	[cs:playcnt],0
	
	or	[cs:eop],2
	call	@swap
	and	[cs:eop],0FDh
	test	[cs:eop],8
	jnz	@@m1
	
@@m0:	pop	dx ax
	iret
endp
; 
proc	@swap
;	sub	[cs:playcnt],65520/DMADIV
;	jnc	@@s1
;	pusha
;	or	[cs:eop],80h
;	mov	bl,[cs:dev]
;	mov	bh,0
;	shl	bx,1
;	call	[cs:haltdev+bx]
;	popa
;	ret
;	
;@@s1:	js	@@s2
	pusha
	push	ds
	mov	ds,[cs:dmaseg]
	mov	cx,32760
	mov	dx,[cs:bufo]
	call	fread
	xor	[cs:bufo],32760
	pop	ds
	popa
@@s2:	ret
endp
; 
hltsb:	call	dspres
	ret
; 
DMAS	=	65520/16-1
proc	irq5r
	;int	3
	push	ax dx
	mov	al,20h
@enop2:	out	0A0h,al
	out	20h,al
	mov	dx,[cs:sbport]
	add	dl,0Eh
	in	al,dx
	
	test	[cs:eop],80h
	jnz	@@m0
;	int	3
;	test	[cs:eop],2
;	jz	@@m1
;	int	3
;	or	[cs:eop],8
;	jmp	@@m0
;	
@@m1:;	and	[cs:eop],0F7h
	add	[cs:reccnt],DMAS+1
	test	[cs:eop],1
	jz	@@m2
	or	[cs:eop],80h
	jmp	@@m0
;	
@@m2:	push	si DMAS 2403h
	mov	si,sp
	call	putdsp
	pop	si si si
;	sti
	
@@m0:	pop	dx ax
	iret
endp
; 
proc	dspres
	mov	dx,[cs:sbport]
	add	dl,6
	mov	al,1
	out	dx,al
	mov	cx,200
@@m1:	in	al,0EDh
	loop	@@m1
	mov	al,0
	out	dx,al
	add	dl,8
@@m2:	in	al,dx
	test	al,80h
	loopz	@@m2
	jcxz	@@m3
	sub	dx,4
	in	al,dx
	cmp	al,0AAh
	jz	@@m3
	stc
@@m3:	ret
endp
; 
proc	coder8
	push	cx
	shr	cx,1
	jcxz	@@m1
	rep	movsw
@@m1:	jnc	@@m2
	movsb
@@m2:	pop	cx
	ret
endp
; 
; INPUT:
;   DS:SI -> input buffer
;   ES:DI -> output buffer
;   CX = input data length
;   setted [cbyte] and [cstate]
; OUTPUT:
;   CX = output data length
;   updated [cbyte] and [cstate]
;	
proc	coder2
	cld
	
	push	di
	mov	bx,offset _decod2

@@y4:	mov	dh,4
@@y3:	push	cx
	mov	ah,0
	lodsb
	sub	al,[cs:cbt1]
	jnc	@@y1
	neg	al
	or	ah,2
@@y1:	mov	cl,[cs:cst1]
	shr	cl,2
	shr	al,cl
	cmp	al,1
	jc	@@y2
	mov	al,1
@@y2:	pop	cx
	or	al,ah
	shl	dl,2
	or	dl,al
	
	or	al,[cs:cst1]
	mov	ah,al
	segcs
	xlat
	mov	[cs:cst1],al
	mov	al,ah
	add	al,18h
	segcs
	xlat
	and	al,al
	js	@@x1
	add	al,[cs:cbt1]
	jnc	@@x2
	mov	al,0FFh
	jmp	@@x2
;	
@@x1:	add	al,[cs:cbt1]
	jc	@@x2
	mov	al,0
@@x2:	mov	[cs:cbt1],al
	
	loop	@@x3
@@x5:	dec	dh
	jz	@@x4
	shl	dl,2
	jmp	@@x5
;	
@@x4:	mov	al,dl
	stosb
	mov	cx,di
	pop	di
	sub	cx,di
	ret
;	
@@x3:	dec	dh
	jnz	@@y3
	mov	al,dl
	stosb
	jmp	@@y4
endp
;	
proc	coder3
	cld
	
	push	di

@@y4:	mov	dh,3
@@y3:	mov	bx,offset _coder3
	mov	al,[cs:cst1]
	cbw
	shl	ax,2
	add	bx,ax
	mov	ah,0
	lodsb
	sub	al,[cs:cbt1]
	jnc	@@y1
	neg	al
	or	ah,4
@@y1:	cmp	al,1Fh
	jc	@@y2
	mov	al,1Fh
@@y2:	segcs
	xlat
	
	or	al,ah
	shl	dl,2
	cmp	dh,1
	jnz	@@y5
	shr	al,1
	or	dl,al
	shl	al,1
	jmp	@@y6
;	
@@y5:	shl	dl,1
	or	dl,al
@@y6:
	mov	bx,offset _decod3
	or	al,[cs:cst1]
	mov	ah,al
	segcs
	xlat
	mov	[cs:cst1],al
	mov	al,ah
	add	al,28h
	segcs
	xlat
	and	al,al
	js	@@x1
	add	al,[cs:cbt1]
	jnc	@@x2
	mov	al,0FFh
	jmp	@@x2
;	
@@x1:	add	al,[cs:cbt1]
	jc	@@x2
	mov	al,0
@@x2:	mov	[cs:cbt1],al
	
	loop	@@x3
	dec	dh
	jz	@@x4
@@x5:	shl	dl,2
	dec	dh
	jz	@@x4
	shl	dl,1
	jmp	@@x5
;	
@@x4:	mov	al,dl
	stosb
	mov	cx,di
	pop	di
	sub	cx,di
	ret
;	
@@x3:	dec	dh
	jz	@@x6
	jmp	@@y3
;	
@@x6:	mov	al,dl
	stosb
	jmp	@@y4
endp
;	
proc	coder4
	cld

	push	di
	mov	bx,offset _decod4

@@y4:	mov	dh,2
@@y3:	mov	ah,0
	lodsb
	sub	al,[cs:cbt1]
	jnc	@@y1
	neg	al
	or	ah,8
@@y1:	push	cx
	mov	cl,[cs:cst1]
	shr	cl,4
	shr	al,cl
	cmp	al,7
	jc	@@y2
	mov	al,7
@@y2:	pop	cx
	or	al,ah
	shl	dl,4
	or	dl,al
	
	or	al,[cs:cst1]
	mov	ah,al
	segcs
	xlat
	mov	[cs:cst1],al
	mov	al,ah
	add	al,40h
	segcs
	xlat
	and	al,al
	js	@@x1
	add	al,[cs:cbt1]
	jnc	@@x2
	mov	al,0FFh
	jmp	@@x2
;	
@@x1:	add	al,[cs:cbt1]
	jc	@@x2
	mov	al,0
@@x2:	mov	[cs:cbt1],al
	
	loop	@@x3
	dec	dh
	jz	@@x4
	shl	dl,4
@@x4:	mov	al,dl
	stosb
	mov	cx,di
	pop	di
	sub	cx,di
	ret
;	
@@x3:	dec	dh
	jnz	@@y3
	mov	al,dl
	stosb
	jmp	@@y4
endp
; 
;jumps
proc	tstfrm
	;int	3
	cld
	push	cs
	pop	es
	mov	[chs],1
	mov	[fpos],0
	mov	[fpos+2],0
	mov	cx,26
	call	@@rd
	jc	@@tsx
	mov	si,dx
	mov	di,offset exa1
	mov	cx,2
	repz	cmpsw
	jnz	@@ts1
	add	si,4
	mov	cx,2
	repz	cmpsw
	jnz	@@ts1
	mov	dx,12			; WAVE detected
	mov	cx,0
	mov	ax,4200h
	int	21h
	call	@@fnd
	jc	@@tsx
	call	@@rdb
	mov	si,offset prebuf+8
	lodsw				; WAVE compression
	mov	[wcm],ax
	lodsw				; Number of tracks
	and	ax,ax
	jz	@@re
	cmp	ax,2
	ja	@@re
	mov	[chs],al
	mov	dx,ax
	lodsw
	shr	ax,1
	cmp	[dev],3
	jnz	@@q2
	mul	dx
@@q2:	call	@setfrq
	add	si,8
	;int	3
	cmp	[wcm],1
	jz	@@q3
	cmp	[wcm],2
	jnz	@@re
	lodsw				; MS ADPCM
	cmp	ax,4
	jnz	@@re
	mov	[srcmp],5
	lodsw
	lodsw
	mov	[gran],ax
	mov	[outsmp],ax
	lodsw
	mov	cx,ax
	mov	[magtn],ax
	mov	di,offset magtbl
	shl	cx,1
	rep	movsw
	jmp	@@w2
;	
@@q3:	lodsw				; Bits per sample
	cmp	ax,8
	jz	@@w2
	cmp	ax,16
	jnz	@@re
	mov	[srcmp],4
@@w2:	mov	di,offset exa3
	call	@@fnd
	jc	@@re
	mov	ax,[word prebuf+4]
	mov	[pllen],ax
	mov	ax,[word prebuf+6]
	mov	[pllen+2],ax
	ret
;	
@@tsx:	stc
	ret
;	
@@ts2:	mov	[chs],1
	test	[mode],10h
	jnz	@@t1
	mov	[srcmp],0
@@t1:	mov	[cs:pllen],-1
	mov	[cs:pllen+2],-1
	clc
	ret
;	
@@ts1:	mov	si,dx
	mov	di,offset exa4
	mov	cx,10
	repz	cmpsw
	jnz	@@ts2
	lodsw
	mov	dx,ax
	lodsw
	mov	cx,ax
	lodsw
	add	ax,cx
	cmp	ax,1233h
	jnz	@@re
	xor	cx,cx			; VOC detected
	mov	ax,4200h
	int	21h
	call	@@fns
	jc	@@re
	;clc
	ret
;	
@@re:	stc
@@ro:	ret
;	
@@fns:	;int	3
	mov	cx,1
	call	@@rd
	jc	@@re
	mov	al,[prebuf]
	and	al,al
	jz	@@ro
	cmp	al,1
	jz	@@f1
	cmp	al,2
	jz	@@f1a
	cmp	al,9
	jz	@@f1b
	mov	cx,3
	mov	dx,offset prebuf+1
	call	@@rd1
	mov	dx,[word prebuf+1]
	mov	cl,[byte prebuf+3]
	xor	ch,ch
	mov	ax,4201h
	int	21h
	jmp	@@fns
;	
@@f1b:	mov	cx,15
	mov	dx,offset prebuf+1
	call	@@rd1
	jc	@@re
	mov	ax,[word prebuf+1]
	mov	dl,[byte prebuf+3]
	xor	dh,dh
	sub	ax,12
	sbb	dx,0
	mov	[pllen],ax
	mov	[pllen+2],dx
	mov	ax,[word prebuf+4]
	shr	ax,1
	call	@setfrq
	mov	al,[byte prebuf+8]
	mov	[srcmp],0
	cmp	al,16
	jnz	@@fx
	mov	[srcmp],4
@@fx:	clc
	ret
;	
@@f1a:	mov	cx,3
	mov	dx,offset prebuf+1
	call	@@rd1
	jc	@@re
	mov	ax,[word prebuf+1]
	mov	dl,[byte prebuf+3]
	xor	dh,dh
	sub	ax,2
	sbb	dx,0
	mov	[pllen],ax
	mov	[pllen+2],dx
	clc
	ret
;	
@@f1:	mov	cx,5
	mov	dx,offset prebuf+1
	call	@@rd1
	jc	@@rt
	mov	ax,[word prebuf+1]
	mov	dl,[byte prebuf+3]
	xor	dh,dh
	sub	ax,2
	sbb	dx,0
	mov	[pllen],ax
	mov	[pllen+2],dx
	mov	cl,[prebuf+4]
	mov	ch,0
	neg	cl
	dec	cl
	inc	cx
	mov	dx,7
	mov	ax,0A120h
	div	cx
	call	@setfrq
@@f2:	mov	al,[prebuf+5]
	test	[mode],10h
	jnz	@@f3
	cmp	al,3
	ja	@@f3
	mov	[srcmp],al
@@f3:	clc
	ret
;	
@@rd:	mov	dx,offset prebuf
@@rd1:	mov	bx,[inf]
	mov	ah,3Fh
	int	21h
	jc	@@rt
	cmp	ax,cx
	jz	@@r2
@@rt:	stc
@@r2:	ret
;	
@@fnd:	mov	cx,8
	call	@@rd
	jc	@@rt
	push	di
	mov	cx,2
	mov	si,dx
	repz	cmpsw
	pop	di
	jz	@@r2
@@fnd2:	mov	dx,[word prebuf+4]
	mov	cx,[word prebuf+6]
	mov	ax,4201h
	int	21h
	jmp	@@fnd
;	
@@rdb:	mov	dx,offset prebuf+8
	mov	cx,[word prebuf+4]
	cmp	cx,512
	jb	@@rd1
	mov	cx,512
	jmp	@@rd1
endp
;nojumps
; 
proc	@setfrq
	test	[mode],20h
	jnz	@@e1
	mov	[freq],ax
	test	[mode2],1
	jnz	@@e1
	mov	[dfrq],ax
	push	ax
	mov	cx,ax
	mov	dx,07h
	mov	ax,0A120h
	div	cx
	neg	al
	mov	[sbtc],al
	pop	ax
@@e1:	ret
endp
; 
@ehlp:	or	[mode],80h
	outdev	DOS
	string
	db	'    XPLAY Version ',VER,13,10
	db	'     ணࠬ  ।⠢  ᮡ  ந뢠⥫  㪮  䠩',13,10
	db	' ࠧ  Sound Blaster/Covox/Speaker  DOS  ⮫쪮  DOS.',13,10
	db	' ஢ 䠩   ᦠ/஬/,  ',13,10
	db	'   Sound Blaster'',      뢠 ᦨ',13,10
	db	'     ᫥騥 㪮 ଠ:',13,10
	db	'.WAV - Microsoft SUXX WAVE, mono/stereo, 8/16-bit  4-bit ADPCM',13,10
	db	'.VOC - Creative Voice file, mono 8-bit, 4/2.6/2-bit ADPCM',13,10
	db	'.??? - VOC  , 㦭 㪠 ᫮  (2/2.6/4/8/16)  ',13,10
	db	'   ஢   ᫥騥 ଠ:',13,10
	db	'.VOC mono 8-bit  4/2.6/2-bit ADPCM',13,10
	db	'    짮 ணࠬ ⠩ help (/?)',13,10
	db	'   ॡ  :',13,10
	db	' -  Intel 80186+ ( AMD ;)',13,10
	db	' - ᢮ ⨢   170 K',13,10
	db	' - Sound Blaster -  易⥫쭮,  ⮣ / १ DMA  ᬮ',13,10
	db	'  - ᫨  SB -    Covox (aka DAC on LPT1)',13,10
	db	'  - ᫨  Covox'',      Speaker''',13,10
	db	'  - ᫨ Speaker'' ⮦ , ⮣ ᬮ ⮫쪮 ஢',13,10
	db	' -    -  ',13,10
	db	' - MS-DOS 3.0+',13,10
	db	' -  -  ',13,10
	db	' - 祭 ⥫쭮  ',13,10
	db	'। ᪮ XPLAY ⥫쭮  Windows   (     ;)',13,10
	db	0
	getkey
	string
	db	13,10,'୮:',13,10,13,10
IF	THANKS
	db	"  T-Rex -  㬥樨  ஢;",13,10
	db	"  SPDR Mad_Max -  প   ,     Blaster;",13,10
	db	"  Wanderer -  DOSAMP (ந뢠⥫ .MP3  DOS);",13,10
	db	"  䥤  -   Pent'  ;",13,10
	db	"  Eugen Roshal -  Far (  - FTP);",13,10
	db	"  䨧 -   ADPCM- .WAV';",13,10
	db	"  QW [194.44.183.209] -  ⮢ .WAV';",13,10
	db	"  Borland' -   TASM;",13,10
	db	"  Microsoft'   筮 -   MustDie'95 ;",13,10
	db	"  (   )",13,10
ELSE
	db	'( )',13,10
ENDIF
	db	0
	outdev	BIOS
	getkey
	string
	db	'Copyright (c) 1996-99 Programmist X',13,10
	db	0
	ret
; 
;macro	estos
;	local	@@z1,@@z2
;	add	bp,[cs:dfrq]
;	jnc	@@ss
;@@st:	stosb
;	sub	bp,[cs:freq]
;	jnc	@@st
;@@ss:
;endm
;	
macro	blods
	local	@@b1
	cmp	si,offset prebuf+32760
	jb	@@b1
	call	_bfill
@@b1:	lodsb
	sub	[cs:bufc],1
endm
;	
proc	fread
	xor	ax,ax
	mov	[cs:nch],1
	test	[cs:eop],1
	jz	@@m2
	ret
;	
@@m2:	mov	bl,[cs:srcmp]
	mov	bh,0
	shl	bx,1
	jmp	[cs:srcomp+bx]
;	
_bfill:	push	ax bx cx dx
	mov	cx,32760
	mov	dx,offset prebuf
	mov	si,dx
	call	intdos
	mov	[cs:bufc],ax
	pop	dx cx bx ax
	ret
;	
intdos:	push	cx
	cmp	[cs:pllen+2],0
	jnz	@@qq
	cmp	cx,[cs:pllen]
	jbe	@@qq
	mov	cx,[cs:pllen]
@@qq:	mov	bx,[cs:inf]
	mov	ah,3Fh
	or	[cs:eop],4
	int	21h
	and	[cs:eop],0FBh
	sub	[cs:pllen],ax
	sbb	[cs:pllen+2],0
	pop	cx
	ret
;	
_srb8:
	;				 -  ...

@@b0:	hlt
	test	[cs:eop],80h
	jnz	@@b2
	mov	ax,[cs:reccnt]
	cmp	ax,cx
	jae	@@b1
	inkey
	jz	@@b0
	getkey
	cmp	ah,1
	jnz	@@b0
	or	[cs:eop],1
	jmp	@@b0
;	
@@b2:	;int	3
	mov	ax,[cs:reccnt]
	cmp	ax,cx
	jbe	@@b3
@@b1:	mov	ax,cx
@@b3:	;int	3
	push	ds es cx si di bx ax ds
	pop	es
	mov	ds,[cs:dmaseg]
	
	mov	si,[cs:playptr]
	mov	di,dx
	mov	bx,offset xltbl
	mov	cx,ax
	jcxz	@@b4

@@b5:	lodsb
	segcs
	xlat
	stosb
	loop	@@b5

@@b4:	pop	ax bx di si cx es ds
	xor	[cs:playptr],cx
	sub	[cs:reccnt],ax
	jmp	@er
;	
_sr0:;	int	3
	cmp	[cs:dev],3
	jz	@@s9
	cmp	[cs:chs],1
	jnz	@@s10
@@s9:	xchg	bp,[cs:_oldbp]
	mov	si,[cs:_oldsi]
	push	cx dx ds es cs ds
	pop	es ds
	mov	di,dx
	mov	bx,offset xltbl
@@s3:	blods
	jc	@@s2
	segcs
	xlat
	add	bp,[cs:dfrq]
	jnc	@@s3
@@st:	stosb
	sub	bp,[cs:freq]
	jnc	@@ss
	loop	@@s3
	jmp	@@s2
;	
@@ss:	loop	@@st
@@s2:	xchg	bp,[cs:_oldbp]
	mov	[cs:_oldsi],si
	mov	ax,cx
	pop	es ds dx cx
	sub	ax,cx
	neg	ax
@@s1:	jmp	@er
;	
@@s10:	push	cx dx ds es cs ds
	pop	es ds
	xchg	bp,[cs:_oldbp]
	mov	si,[cs:_oldsi]
	mov	di,dx
	mov	bx,offset xltbl
@@s12:	blods
	jc	@@s11a
	mov	ah,al
	blods
	jc	@@s11a
	add	al,ah
	rcr	al,1
	segcs
	xlat
	add	bp,[cs:dfrq]
	jnc	@@s12
@@s12a:	stosb
	sub	bp,[cs:freq]
	jnc	@@s12b
	loop	@@s12
	jmp	@@s11a
;	
@@s12b:	loop	@@s12a
@@s11a:	xchg	bp,[cs:_oldbp]
	mov	[cs:_oldsi],si
	mov	ax,cx
	pop	es ds dx cx
	sub	ax,cx
	neg	ax
	jmp	@er
;	
_sr4:	;int	3
	push	cx dx ds es cs ds
	pop	es ds
	xchg	bp,[cs:_oldbp]
	mov	si,[cs:_oldsi]
	mov	di,dx
	mov	dl,1
@@x3:	mov	bx,offset _decod4
	dec	dl
	jnz	@@x4
	blods
	jc	@@x5
	xchg	al,ah
	mov	dl,2
@@x4:	xor	al,al
	rol	ax,4
	or	al,[cstat]
	mov	dh,al
	xlat
	mov	[cstat],al
	mov	al,dh
	add	al,40h
	xlat
	and	al,al
	js	@@x1
	add	al,[cbyte]
	jnc	@@x2
	mov	al,0FFh
	jmp	@@x2
;	
@@x1:	add	al,[cbyte]
	jc	@@x2
	mov	al,0
@@x2:	mov	[cbyte],al
	mov	bx,offset xltbl
	xlat
	add	bp,[cs:dfrq]
	jnc	@@x3
@@x2b:	stosb
	sub	bp,[cs:freq]
	jnc	@@x2a
	loop	@@x3
	jmp	@@x5
;	
@@x2a:	loop	@@x2b
@@x5:	xchg	bp,[cs:_oldbp]
	mov	[cs:_oldsi],si
	mov	ax,cx
	pop	es ds dx cx
	sub	ax,cx
	neg	ax
	jmp	@er
;	
_sr3:	push	cx dx ds es cs ds
	pop	es ds
	xchg	bp,[cs:_oldbp]
	mov	si,[cs:_oldsi]
	mov	di,dx
	mov	dl,1
@@y3:	mov	bx,offset _decod3
	dec	dl
	jnz	@@y4
	blods
	jc	@@y6
	mov	ah,al
	mov	dl,3
@@y4:	xor	al,al
	rol	ax,3
	or	al,[cstat]
	mov	dh,al
	xlat
	mov	[cstat],al
	mov	al,dh
	add	al,28h
	xlat
	and	al,al
	js	@@y1
	add	al,[cbyte]
	jnc	@@y2
	mov	al,0FFh
	jmp	@@y2
;	
@@y1:	add	al,[cbyte]
	jc	@@y2
	mov	al,0
@@y2:	mov	[cbyte],al
	mov	bx,offset xltbl
	xlat
	add	bp,[cs:dfrq]
	jnc	@@y3
@@y2b:	stosb
	sub	bp,[cs:freq]
	jnc	@@y2a
	loop	@@y3
	jmp	@@y6
;	
@@y2a:	loop	@@y2b
@@y6:	xchg	bp,[cs:_oldbp]
	mov	[cs:_oldsi],si
	mov	ax,cx
	pop	es ds dx cx
	sub	ax,cx
	neg	ax
	jmp	@er
;	
_sr2:	push	cx dx ds es cs ds
	pop	es ds
	xchg	bp,[cs:_oldbp]
	mov	si,[cs:_oldsi]
	mov	di,dx
	mov	dl,1
@@z3:	mov	bx,offset _decod2
	dec	dl
	jnz	@@z4
	blods
	jc	@@z5
	mov	ah,al
	mov	dl,4
@@z4:	xor	al,al
	rol	ax,2
	or	al,[cstat]
	mov	dh,al
	xlat
	mov	[cstat],al
	mov	al,dh
	add	al,18h
	xlat
	and	al,al
	js	@@z1
	add	al,[cbyte]
	jnc	@@z2
	mov	al,0FFh
	jmp	@@z2
;	
@@z1:	add	al,[cbyte]
	jc	@@z2
	mov	al,0
@@z2:	mov	[cbyte],al
	mov	bx,offset xltbl
	xlat
	add	bp,[cs:dfrq]
	jnc	@@z3
@@z2b:	stosb
	sub	bp,[cs:freq]
	jnc	@@z2a
	loop	@@z3
	jmp	@@z5
;	
@@z2a:	loop	@@z2b
@@z5:	xchg	bp,[cs:_oldbp]
	mov	[cs:_oldsi],si
	mov	ax,cx
	pop	es ds dx cx
	sub	ax,cx
	neg	ax
	jmp	@er
;	
_sr16:	;int	3
	push	cx dx ds es cs ds
	pop	es ds
	xchg	bp,[cs:_oldbp]
	mov	si,[cs:_oldsi]
	mov	di,dx
	
;	mov	ax,2
;@@t2:	push	cx ax
;	mov	dx,offset prebuf
;	mov	si,dx
;	call	intdos
;	cmp	ax,cx
;	jz	@@t3
;	or	[cs:eop],1
;@@t3:	shr	ax,1
	mov	dx,cx
	mov	cl,[cs:sh16]
	mov	bx,offset xltbl
@@t1:	blods
	jc	@@t5
	mov	ah,al
	blods
	jc	@@t5
	xchg	ah,al
	sar	ax,cl
	add	al,80h
	segcs
	xlat
	add	bp,[cs:dfrq]
	jnc	@@t1
@@t2b:	stosb
	sub	bp,[cs:freq]
	jnc	@@t2a
	dec	dx
	jnz	@@t1
	jmp	@@t5
;	
@@t2a:	dec	dx
	jnz	@@t2b
@@t5:	xchg	bp,[cs:_oldbp]
	mov	[cs:_oldsi],si
	mov	ax,dx
	pop	es ds dx cx
	sub	ax,cx
	neg	ax
	jmp	@er
;	
_srw4:	push	bx cx dx ds es cs ds
	pop	es ds
	xchg	bp,[cs:_oldbp]
	mov	di,dx
	mov	si,[oiptr]
	jcxz	@@w14s
@@w14:	mov	ax,[outsmp]
	cmp	ax,[gran]
	jnz	@@w1
	mov	[outsmp],2
	push	cx
	xor	ah,ah
	mov	cx,[gran]
	shr	cx,1
	add	cx,6
	cmp	[chs],1
	jz	@@w14a
	add	cx,cx
@@w14a:	mov	dx,offset prebuf
	call	intdos
	mov	si,dx
	cmp	ax,cx
	jnz	@@w0a
	mov	cl,[chs]
	xor	ch,ch
@@w2:	lodsb
	cmp	al,[byte magtn]
	jb	@@w1a
@@w0a:	pop	cx
	jmp	@@w0
;	
@@w1a:	mov	bl,al
	mov	bh,0
	shl	bl,2
	mov	ax,[magtbl+bx+2]
	mov	dx,[magtbl+bx]
	mov	bl,[chs]
	sub	bl,cl
	shl	bl,1
	
	mov	[extrw+bx],ax		; m pre-pre
	mov	[extrw+bx+4],dx		; m pre
	loop	@@w2
	
	irp	z,8,12,16
	local	@@w3,@@qqq
	mov	cl,[chs]
	mov	bl,0
@@w3:	lodsw

	mov	[extrw+bx+z],ax
	inc	bx
	inc	bx
	loop	@@w3
	endm
	pop	cx
	mov	[ccnl],0
	mov	[nibbl],1
@@w1:;	int	3
	xor	[nibbl],1
	test	[nibbl],1
	jz	@@w4
	lodsb
	sal	al,4
	jmp	@@w5
;	
@@w4:	mov	al,[si]
@@w5:	sar	al,4
	mov	[rdbt],al
	mov	bl,al
	push	si
	mov	si,[ccnl]
	mov	ax,[extrw+si+8]
	mov	[st1],ax
	and	bx,0Fh
	shl	bl,1
	imul	[tblw1+bx]
	mov	al,ah
	mov	ah,dl
	cmp	ax,10h
	jge	@@w7
	mov	ax,10h
@@w7:	mov	[extrw+si+8],ax
	mov	ax,[extrw+si+4]
	imul	[extrw+si+12]
	mov	[tmp1],ax
	mov	[tmp1+2],dx
	mov	ax,[extrw+si]
	imul	[extrw+si+16]
	add	ax,[tmp1]
	adc	dx,[tmp1+2]
	mov	al,ah
	mov	ah,dl
	mov	dl,dh
	shl	dh,1
	sbb	dh,dh
	mov	[tmp1],ax
	mov	[tmp1+2],dx
	mov	al,[rdbt]
	cbw
	imul	[st1]
	add	ax,[tmp1]
	adc	dx,[tmp1+2]
	and	dx,dx
	jnz	@@w8
	cmp	ax,7FFFh
	jbe	@@w10
@@w9:	mov	ax,7FFFh
	mov	dx,0
	jmp	@@w10
;	
@@w8:	jns	@@w9
	cmp	dx,-1
	jnz	@@w11
	cmp	ax,8000h
	jae	@@w10
@@w11:	mov	ax,8000h
	mov	dx,-1
@@w10:	mov	[tmp1],ax
	mov	ax,[extrw+si+12]
	mov	[extrw+si+16],ax
	mov	ax,[tmp1]
	mov	[extrw+si+12],ax
	mov	bx,offset xltbl
	cmp	[chs],1
	jz	@@w16
	inc	si
	inc	si
	cmp	[dev],3
	jz	@@w13
;	jmp	@@w13
	cmp	si,2
	jbe	@@w17
	xor	si,si
	inc	[outsmp]
@@w12a:	mov	al,[byte extrw+13]
	mov	ah,[byte extrw+15]
	xor	ax,8080h
	add	al,ah
	rcr	al,1
	xlat
	stosb
	jmp	@@w12
;	
@@w17:	mov	[ccnl],si
	pop	si
	jmp	@@w14
;	
@@w13:	cmp	si,2
	jbe	@@w15
	xor	si,si
@@w16:	inc	[outsmp]
@@w15:	mov	al,[byte tmp1+1]
	add	al,80h
	xlat
	stosb
@@w12:	mov	[ccnl],si
	pop	si
	loop	@@w14
@@w14s:	mov	[oiptr],si
@@w0:	xchg	bp,[cs:_oldbp]
	pop	es ds dx cx bx
	mov	ax,di
	sub	ax,dx
	jmp	@er
;	
@er:	add	[cs:playcnt],ax
	cmp	ax,cx
	jz	@@m1
	or	[cs:eop],1
	push	cx
	mov	si,dx
	add	si,ax
	sub	cx,ax
	shr	cx,1
;	pushf
	jcxz	@@m3
@@m4:	mov	[word si],8080h
	inc	si
	inc	si
	loop	@@m4
@@m3:;	popf
	jnc	@@m5
	mov	[byte si],80h	
@@m5:	pop	cx
@@m1:	string	'.'
	ret
endp
; 
proc	@putb
;	int	3
	mov	[cs:lch],al
	mov	ah,[cs:nch]
	cmp	ah,[cs:chs]
	jnz	@@p1
	add	al,[cs:lch]
	rcr	al,1
	segcs
	xlat
	stosb
	xor	ah,ah
@@p1:	inc	ah
	mov	[cs:nch],ah
	ret
endp
; 
_decod2:hex	<00,04,00,04,00,08,00,08,04,0C,04,0C,08,10,08,10>
	hex	<0C,14,0C,14,10,14,10,14>
	db	+00,+01,-00,-01,+01,+03,-01,-03,+02,+06,-02,-06,+04,+12,-04,-12
	db	+08,+24,-08,-24,+16,+48,-16,-48
;	
_coder3:db	0,1,2,3,3,3,3,3,3,3,3,3,3,3,3,3
	db	3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3
	db	0,0,1,1,2,2,3,3,3,3,3,3,3,3,3,3
	db	3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3
	db	0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3
	db	3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3
	db	0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1
	db	2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3
	db	0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1
	db	1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,3
_decod3:hex	<00,00,00,08,00,00,00,08,00,08,08,10,00,08,08,10>
	hex	<08,10,10,18,08,10,10,18,10,18,18,20,10,18,18,20>
	hex	<18,20,20,20,18,20,20,20>
	db	+00,+01,+02,+03,-00,-01,-02,-03,+01,+03,+05,+07,-01,-03,-05,-07
	db	+02,+06,+10,+14,-02,-06,-10,-14,+04,+12,+20,+28,-04,-12,-20,-28
	db	+05,+15,+25,+35,-05,-15,-25,-35
;	
_decod4:hex	<00,00,00,00,00,10,10,10,00,00,00,00,00,10,10,10>
	hex	<00,10,10,10,10,20,20,20,00,10,10,10,10,20,20,20>
	hex	<10,20,20,20,20,30,30,30,10,20,20,20,20,30,30,30>
	hex	<20,30,30,30,30,30,30,30,20,30,30,30,30,30,30,30>
	db	+00,+01,+02,+03,+04,+05,+06,+07,-00,-01,-02,-03,-04,-05,-06,-07
	db	+01,+03,+05,+07,+09,+11,+13,+15,-01,-03,-05,-07,-09,-11,-13,-15
	db	+02,+06,+10,+14,+18,+22,+26,+30,-02,-06,-10,-14,-18,-22,-26,-30
	db	+04,+12,+20,+28,+36,+44,+52,+60,-04,-12,-20,-28,-36,-44,-52,-60
; 
dataseg
tmpvar	db	'TMP='
blast	db	'BLASTER='
exa1	db	'RIFFWAVE'
exa2	db	'fmt '
exa3	db	'data'
exa4	db	'Creative Voice File',26
	hex	<1A,00,0A,01,29,11,01,00,00,00>
sbtc	db	211		; Time constant for Sound Blaster
cmpd	db	0
cbt1	db	80h		; ADPCM cumulative byte (encoding)
cst1	db	0		; ADPCM status byte     (encoding)
cbyte	db	80h		; ADPCM cumulative byte (decoding)
cstat	db	0		; ADPCM status byte     (decoding)
dscm	db	1		; Compression of destination file
mode	db	0	; Command line flags:
; Ŀ
; 
;           1 = option /DS# present
;          1 = option /L present
;         1 = option /SB present
;      1 = option /SR# present
;     1 = option /U:# present
;    1 = play device present
;   1 = filename present
mode2	db	0
; Ŀ
; 
;                 1 = option /F:# present
dev	db	0		; Device to play
eop	db	0	; Play status:
; Ŀ
; 
;           1 = end-of-file detected
;          1 = reading from input file
;         1 = DOS active
;        1 = IRQ delayed
;     1 = key pressed
;    1 = Ctrl-Break pressed
;   1 = play terminated
rdbt	db	0
tim	db	0		; Time constant for system timer
sptim	db	62		; Timer constant for PC Speaker
svol	db	32		; Volume for Speaker and Covox
srcmp	db	0		; Compression of source file
chs	db	1		; Number of channels
sh16	db	8		; Shift for 16-bit files
delta	db	0
nch	db	0
lch	db	0
nibbl	db	0
dmamod	db	58h
align	2
sbport	dw	220h
sbirq	db	5
sbdma	db	1
dmapg	db	87h,83h,81h,82h
tblw1	dw	4 dup (0E6h),133h,199h,200h,266h,300h,266h,200h,199h,133h,3 dup (0E6h)
srcomp	dw	_sr0,_sr4,_sr3,_sr2,_sr16,_srw4,_srb8
compp	dw	coder8,coder4,coder3,coder2
initdev	dw	inispk,inicov,inicov,inisb
playdev	dw	plaspk,placov,placov,plasb
haltdev	dw	clsspk,clsspk,clsspk,hltsb
closdev	dw	clsspk,clscov,clscov,clssb
fn1	dw	0
fn2	dw	0
count	dw	1
plpt	dw	256
freq	dw	11025
dfrq	dw	11025
oport	dw	42h
wcm	dw	?
pllen	dw	?,?
gran	dw	?
outsmp	dw	?
ccnl	dw	?
playptr	dw	?
st1	dw	?
playcnt	dw	?
playlen	dw	?
reccnt	dw	?
olen	dw	?
inf	dw	?
outf	dw	?
outln	dw	?
oiptr	dw	?
coder	dw	?
bufo	dw	?
bufc	dw	?
_oldbp	dw	?
_oldsi	dw	?
dmaseg	dw	?
extseg	dw	?
tmp1	dw	?,?,?,?
fpos	dw	?,?
oi5	dw	?,?
oi8	dw	?,?
oi1b	dw	?,?
unifn	db	64 dup (?)	; Directory for temporary file
xltbl	db	256 dup (?)
spkxlt	db	256 dup (?)
magtn	dw	?
magtbl	dw	32 dup (?,?)
extrw	dw	6 dup (?,?)
prebuf	db	32760 dup (?)
	dw	100h dup (?)
eopr:
end